{{
**********************************
* jvmEngine - executes bytecodes *
**********************************
}}


CON
  'first 64
  Jem_NOP               = $00
  Jem_ICONST_M1         = $01
  Jem_ICONST_0          = $02
  Jem_ICONST_1          = $03
  Jem_ICONST_2          = $04
  Jem_ICONST_3          = $05
  Jem_ICONST_4          = $06
  Jem_ICONST_5          = $07
  Jem_BIPUSH            = $08
  Jem_SIPUSH            = $09
  Jem_ILOAD             = $0A
  Jem_ILOAD_0           = $0B
  Jem_ILOAD_1           = $0C
  Jem_ILOAD_2           = $0D
  Jem_ILOAD_3           = $0E
  Jem_ISTORE            = $0F
  Jem_ISTORE_0          = $10
  Jem_ISTORE_1          = $11
  Jem_ISTORE_2          = $12
  Jem_ISTORE_3          = $13
  Jem_IFEQ              = $14
  Jem_IFNE              = $15
  Jem_IFLT              = $16
  Jem_IFLE              = $17
  Jem_IFGT              = $18
  Jem_IFGE              = $19
  Jem_IF_ICMPEQ         = $1A
  Jem_IF_ICMPNE         = $1B
  Jem_IF_ICMPLT         = $1C
  Jem_IF_ICMPGE         = $1D
  Jem_IF_ICMPGT         = $1E
  Jem_IF_ICMPLE         = $1F
  Jem_IF_ACMPEQ         = $20
  Jem_IF_ACMPNE         = $21
  Jem_IRETURN           = $22
  Jem_RETURN            = $23
  Jem_INVOKEVIRTUAL     = $24
  Jem_INVOKESTATIC      = $25
  Jem_GETSTATIC         = $26
  Jem_PUTSTATIC         = $27
  Jem_POP               = $28
  Jem_POP2              = $29
  Jem_DUP               = $2A
  Jem_DUP_X1            = $2B
  Jem_DUP_X2            = $2C
  Jem_DUP2              = $2D
  Jem_DUP2_X1           = $2E
  Jem_DUP2_X2           = $2F
  Jem_SWAP              = $30
  Jem_IADD              = $31
  Jem_ISUB              = $32
  Jem_INEG              = $33
  Jem_IOR               = $35
  Jem_ISHL              = $37
  Jem_ISHR              = $39
  Jem_IUSHR             = $3B
  Jem_IAND              = $3D
  Jem_IXOR              = $3F
  Jem_I2B               = $41
  Jem_GOTO              = $43
  Jem_INVOKEINTERFACE   = $45
  Jem_ARRAYLENGTH       = $47
  Jem_ATHROW            = $49
  Jem_CHECKCAST         = $4B
  'next 64
  Jem_INSTANCEOF        = $4D
  Jem_WIDE              = $4F
  Jem_IINC              = $51
  Jem_GETFIELD          = $53
  Jem_PUTFIELD          = $55
  Jem_NEW               = $57
  Jem_NEWARRAY          = $59
  Jem_ANEWARRAY         = $5B
  Jem_IALOAD            = $5D
  Jem_IASTORE           = $5F
  Jem_BALOAD            = $61
  Jem_BASTORE           = $63
  Jem_LDC               = $65
  Jem_LDC_W             = $67
  Jem_LDC2_W            = $69
  Jem_IMUL              = $6B
  Jem_IDIV              = $6D
  Jem_IREM              = $6F
  Jem_JSR               = $71
  Jem_RET               = $73
  Jem_TABLESWITCH       = $75
  Jem_LOOKUPSWITCH      = $77


OBJ

  jd:            "jvmDataAsm" 'jvm memory access object


VAR

  long  HandlerCog        

                              
PUB start(addrJvmVars, addrJemCode)

  stop
  PtrJvmVars := addrJvmVars
  PtrJemCode := addrJemCode
  PtrJemCodeJmpTable := @JemCodeJmpTable
  
  HandlerCog := cognew(@handlerEntry, 0) + 1


PUB stop

  if HandlerCog
    cogstop(HandlerCog~ - 1)


DAT
{{
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
                        A S S E M B L Y   S E C T I O N

}}
handlerEntry            org     0

sendReady               xor     _jemcode,_jemcode
                        wrbyte  _jemcode,PtrJemCode
:wait4jemcode           rdbyte  _jemcode,PtrJemCode     'wait for next jemcode
                        tjz     _jemcode,#:wait4jemcode
                        cmp     _jemcode,#Jem_SWAP  wc, wz
        if_a            jmp     #:wait4jemcode          'not handled by this decoder
                        mov     Tmp,_jemcode
                        shl     Tmp,#1                  'jump table entries are words
                        add     Tmp,PtrJemCodeJmpTable
                        rdword  Tmp,Tmp                 'get address of jemcode handler
                        jmp     Tmp                     'handle byte code

{{
############################## JEMCODE HANDLER ################################
}}
{{
_______________________________________________________________________________
function: jb_iconst_M1()
Push the integer constant -1.

}}
jb_iconst_M1            mov     Param1,MASK_WORD
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_0()
Push the integer constant 0.

}}
jb_iconst_0             mov     Param1,#0
jb_iconst_X             call    #push
                        call    #incJvmPC
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iconst_1()
Push the integer constant 1.

}}
jb_iconst_1             mov     Param1,#1
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_2()
Push the integer constant 2.

}}
jb_iconst_2             mov     Param1,#2
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_3()
Push the integer constant 3.

}}
jb_iconst_3             mov     Param1,#3
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_4()
Push the integer constant 4.

}}
jb_iconst_4             mov     Param1,#4
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_iconst_5()
Push the integer constant 5.

}}
jb_iconst_5             mov     Param1,#5
                        jmp     #jb_iconst_X

{{
_______________________________________________________________________________
function: jb_bipush()
Push a 1-byte signed integer.

}}
jb_bipush               call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaByte
                        call    #b2i
                        mov     Param1,jvmResult
jb_xpush                call    #push
                        call    #incJvmPC2Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_sipush()
Push a 2-byte signed integer.

}}
jb_sipush               call    #getJvmPC
                        add     jvmPC,#1
                        mov     Param1,jvmPC
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        jmp     #jb_xpush


{{
_______________________________________________________________________________
function: jb_iload()
Load integer from local variable.

}}
jb_iload                call    #getJvmPC
                        add     jvmPC,#1
                        mov     Param1,jvmPC
                        call    #readJavaByte
                        shl     jvmResult,#1
jb_iload_x              call    #getJvmFP
                        mov     Param1,jvmFP
                        add     Param1,jvmResult
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        call    #push
                        call    #incJvmPCAgain
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iload_0()
Load integer from local variable with index 0.

}}
jb_iload_0              mov     jvmResult,#0
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_1()
Load integer from local variable with index 1.

}}
jb_iload_1              mov     jvmResult,#1 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_2()
Load integer from local variable with index 2.

}}
jb_iload_2              mov     jvmResult,#2 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_3()
Load integer from local variable with index 3.

}}
jb_iload_3              mov     jvmResult,#3 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_4()
Load integer from local variable with index 4.

}}
jb_iload_4              mov     jvmResult,#4 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_iload_5()
Load integer from local variable with index 5.

}}
jb_iload_5              mov     jvmResult,#5 * jd#JVM_INT_SIZE
                        jmp     #jb_iload_x

{{
_______________________________________________________________________________
function: jb_istore()
Store integer into local variable.

}}
jb_istore               call    #getJvmPC
                        add     jvmPC,#1
                        mov     Param1,jvmPC
                        call    #readJavaByte
                        shl     jvmResult,#1
                        mov     Tmp,jvmResult
jb_istore_x             call    #pop
                        mov     Param2,jvmResult
                        call    #getJvmFP
                        mov     Param1,jvmFP
                        add     Param1,Tmp
                        call    #writeJavaIntBE
                        call    #incJvmPCAgain
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_istore_0()
Store integer into local variable with index 0.

}}
jb_istore_0             mov     Tmp,#0
                        jmp     #jb_istore_x

{{
_______________________________________________________________________________
function: jb_istore_1()
Store integer into local variable with index 1.

}}
jb_istore_1             mov     Tmp,#1 * jd#JVM_INT_SIZE
                        jmp     #jb_istore_x
{{
_______________________________________________________________________________
function: jb_istore_2()
Store integer into local variable with index 2.

}}
jb_istore_2             mov     Tmp,#2 * jd#JVM_INT_SIZE
                        jmp     #jb_istore_x
{{
_______________________________________________________________________________
function: jb_istore_3()
Store integer into local variable with index 3.

}}
jb_istore_3             mov     Tmp,#3 * jd#JVM_INT_SIZE
                        jmp     #jb_istore_x

{{
_______________________________________________________________________________
function: jb_ifeq()
Branch if equal to 0.

}}
jb_ifeq                 call    #jb_ifx
jb_if_icmpeqx
        if_z            call    #addN2JvmPCAgain
        if_nz           call    #incJvmPC3Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifne()
Branch if not equal to 0.

}}
jb_ifne                 call    #jb_ifx
jb_if_icmpnex
        if_nz           call    #addN2JvmPCAgain
        if_z            call    #incJvmPC3Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_iflt()
Branch if less than 0.

}}
jb_iflt                 call    #jb_ifx
jb_if_icmpltx
        if_c            call    #addN2JvmPCAgain
        if_nc           call    #incJvmPC3Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifle()
Branch if less than or equal to 0.

}}
jb_ifle                 call    #jb_ifx
jb_if_icmplex
        if_c_OR_z       call    #addN2JvmPCAgain
        if_nc_AND_nz    call    #incJvmPC3Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifgt()
Branch if greater than 0.

}}
jb_ifgt                 call    #jb_ifx
jb_if_icmpgtx
        if_nc           call    #addN2JvmPCAgain
        if_c            call    #incJvmPC3Again
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_ifge()
Branch if greater than or equal to 0.

}}
jb_ifge                 call    #jb_ifx
jb_if_icmpgex
        if_nc_OR_z      call    #addN2JvmPCAgain
        if_c_AND_nz     call    #incJvmPC3Again
                        jmp     #sendReady

jb_ifx                  call    #popi2l
                        cmps    jvmResult,#0  wc, wz
jb_if_icmpN             call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE
                        mov     jvmTmp,jvmResult
jb_ifx_ret
jb_if_icmpN_ret         ret

{{
_______________________________________________________________________________
function: jb_if_acmpeq()
Branch if object references are equal.

}}
jb_if_acmpeq

{{
_______________________________________________________________________________
function: jb_if_icmpeq()
Branch if integers v1 and v2 are equal.

}}
jb_if_icmpeq            call    #jb_if_icmpx
                        jmp     #jb_if_icmpeqx

{{
_______________________________________________________________________________
function: jb_if_acmpne()
Branch if object references are not equal.

}}
jb_if_acmpne

{{
_______________________________________________________________________________
function: jb_if_icmpne()
Branch if integers v1 and v2 are not equal.

}}
jb_if_icmpne            call    #jb_if_icmpx
                        jmp     #jb_if_icmpnex

{{
_______________________________________________________________________________
function: jb_if_icmplt()
Branch if integer v1 is less than integer v2.

}}
jb_if_icmplt            call    #jb_if_icmpx
                        jmp     #jb_if_icmpltx

{{
_______________________________________________________________________________
function: jb_if_icmpge()
Branch if integer v1 is greater than or equal to integer v2.

}}
jb_if_icmpge            call    #jb_if_icmpx
                        jmp     #jb_if_icmpgex

{{
_______________________________________________________________________________
function: jb_if_icmpgt()
Branch if integer v1 is greater than integer v2.

}}
jb_if_icmpgt            call    #jb_if_icmpx
                        jmp     #jb_if_icmpgtx

{{
_______________________________________________________________________________
function: jb_if_icmple()
Branch if integer v1 is less than or equal to integer v2.

}}
jb_if_icmple            call    #jb_if_icmpx
                        jmp     #jb_if_icmplex

jb_if_icmpx             call    #popi2l
                        mov     Tmp,jvmResult
                        call    #popi2lAgain
                        cmps    jvmResult,Tmp  wc, wz
                        call    #jb_if_icmpN
jb_if_icmpx_ret         ret

{{
_______________________________________________________________________________
function: jb_ireturn()
Return integer from function.

}}
jb_ireturn              call    #pop
                        mov     Param2,jvmResult
                        call    #jb_returnInternal      'discard frame
                        call    #pushAgain
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_return()
Return (void) from method.

}}
jb_return               call    #jb_returnInternal
                        jmp     #sendReady

jb_returnInternal       call    #getJvmMP
                        mov     Param1,jvmMP
                        'not necessary, offset is 0: add     Param1,#jd#JVM_PARAMETERS
                        call    #readJavaByte
                        mov     Tmp,jvmResult
                        and     Tmp,#$7F
                        mov     Param1,jvmMP
                        add     Param1,#jd#JVM_LOCALS                        
                        call    #readJavaByte
                        add     Tmp,jvmResult
                        call    #getJvmFP
                        mov     jvmSP,jvmFP
                        add     jvmSP,Tmp
                        mov     Param1,jvmSP
                        call    #readJavaIntBE
                        mov     jvmMP,jvmResult
                        call    #updateJvmMP
                        mov     Param1,jvmSP
                        add     Param1,#jd#JVM_INT_SIZE
                        call    #readJavaIntBE
                        mov     jvmFP,jvmResult
                        call    #updateJvmFP
                        mov     Param1,jvmSP
                        add     Param1,#2 * jd#JVM_INT_SIZE
                        call    #readJavaIntBE
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC
                        sub     jvmSP,Tmp
                        call    #updateJvmSP
jb_returnInternal_ret   ret

{{
_______________________________________________________________________________
function: jb_invokevirtual()
Invoke method based on runtime type.
  byte2 is offset to begin of class method table (so if byte = $2D and class method table = $60, method header = $8D)
  byte1 is offset to sp to find object reference (so if sp = $3FF6 and byte1 = $04 then the aref is at $3FF6-$04 = $3FF2)

}}
jb_invokevirtual        call    #getJvmSP
                        call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaByte           'get offset from sp where aref is stored
                        mov     jvmFP,jvmSP
                        sub     jvmFP,jvmResult         'calculate address of possibly new frame
                        mov     Param1,jvmFP
                        call    #readJavaIntBE          'get aref
                        tjz     jvmResult,#throwNPE
                        mov     Param1,jvmResult
                        call    #readJavaIntBE          'get address of class descriptor
                        mov     Tmp,jvmResult
                        mov     Param1,jvmPC
                        add     Param1,#2
                        call    #readJavaByte           'get address of method descriptor
                        add     Tmp,jvmResult
                        jmp     #invokeInternal
                        
{{
_______________________________________________________________________________
function: jb_invokestatic()
Invoke a class (static) method.
  byte1 and byte2 form 16bits address to method header: addr = (byte1<<8)|(byte2) 

}}
jb_invokestatic         call    #getJvmSP
                        mov     jvmFP,jvmSP
                        call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE
                        mov     Tmp,jvmResult
                        mov     Param1,Tmp
                        'not necessary, offset is 0: add     Param1,jd#JVM_PARAMETERS
                        call    #readJavaByte
                        and     jvmResult,#$7F
                        sub     jvmFP,jvmResult
invokeInternal          mov     Param1,Tmp
                        add     Param1,#jd#JVM_FLAGS
                        call    #readJavaByte
                        tjnz    jvmResult,#:chkNative
                        'not native
                        mov     Param1,Tmp           
                        add     Param1,#jd#JVM_LOCALS
                        call    #readJavaByte
                        add     jvmSP,jvmResult
                        call    #getJvmMP
                        mov     Param2,jvmMP
                        mov     Param1,jvmSP
                        call    #writeJavaIntBE         'save old mp
                        add     Param1,#jd#JVM_INT_SIZE
                        mov     jvmResult,jvmFP
                        call    #getJvmFP
                        mov     Param2,jvmFP
                        call    #writeJavaIntBE         'save old fp
                        mov     jvmFP,jvmResult
                        add     Param1,#jd#JVM_INT_SIZE
                        mov     Param2,jvmPC
                        add     Param2,#3
                        call    #writeJavaIntBE         'save old pc (= return address)
                        call    #updateJvmFP            'set new fp
                        mov     jvmMP,Tmp
                        call    #updateJvmMP            'set new mp
                        mov     jvmSP,Param1
                        add     jvmSP,#jd#JVM_INT_SIZE
                        call    #updateJvmSP            'set new sp
                        mov     Param1,jvmMP
                        add     Param1,#jd#JVM_CODE
                        call    #readJavaIntBE
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC            'set new pc
                        jmp     #sendReady
                        
:chkNative              cmp     jvmResult,#$80  wz
        if_nz           jmp     #sendReady
                        mov     Param1,Tmp
                        add     Param1,jd#JVM_CODE
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        call    #doNative
incJvmPC3End            call    #incJvmPC3
                        jmp     #sendReady

{{
_______________________________________________________________________________
function: jb_getstatic()
Get 32-bit static field from class.
  byte1 and byte2 form 16bits offset into static variables area: offset = (byte1<<8)|(byte2) 

}}
jb_getstatic            call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE          'get offset
                        mov     jvmVar,jd#varStaticBase
                        call    #getJvmVar
                        mov     Param1,jvmVar
                        add     Param1,jvmResult        'add offset
                        call    #readJavaIntBE
                        mov     Param1,jvmResult
                        call    #push                   'return value
                        jmp     #incJvmPC3End

{{
_______________________________________________________________________________
function: jb_putstatic()
Set 32-bit static field in class.
  byte1 and byte2 form 16bits offset into static variables area: offset = (byte1<<8)|(byte2) 

}}
jb_putstatic            call    #pop
                        mov     Param2,jvmResult
                        call    #getJvmPC
                        mov     Param1,jvmPC
                        add     Param1,#1
                        call    #readJavaIntBE
                        mov     jvmVar,#jd#varStaticBase
                        call    #getJvmVar
                        mov     Param1,jvmResult
                        add     Param1,#jvmVar
                        call    #writeJavaIntBE
                        jmp     #incJvmPC3End

{{
_______________________________________________________________________________
function: jb_pop()
Pop the top word from the stack.

}}
jb_pop                  call    #pop
incJvmPCEnd             call    #incJvmPC
                        jmp     #sendReady
                        
{{
_______________________________________________________________________________
function: jb_pop2()
Pop the top two words from the stack.

}}
jb_pop2                 call    #pop
                        jmp     #jb_pop

{{
_______________________________________________________________________________
function: jb_dup()
Duplicate the top word on the stack.

}}
jb_dup                  call    #pop
                        mov     Param2,jvmResult
                        call    #pushAgain
                        call    #pushAgain
                        jmp     #incJvmPCEnd

{{
_______________________________________________________________________________
function: jb_dup_x1()
Duplicate the top word on the stack and insert a copy two words down in the stack.

}}
jb_dup_x1               call    #pop
                        mov     Tmp,jvmResult
                        call    #popAgain
                        mov     Param2,#Tmp
                        call    #pushAgain
dup_x2                  mov     Param2,#jvmResult
swap                    call    #pushAgain
                        mov     Param2,Tmp
                        call    #pushAgain
                        jmp     #incJvmPCEnd

{{
_______________________________________________________________________________
function: jb_dup_x2()
Duplicate the top word on the stack and insert the copy three words down in the stack.

}}
jb_dup_x2               call    #pop
                        mov     Tmp,jvmResult
                        call    #popAgain
                        mov     Param2,jvmResult
                        call    #popAgain
dup2_x1                 mov     Param2,#Tmp
                        call    #pushAgain
dup2_x2                 mov     Param1,Param2
                        mov     Param2,jvmResult
                        mov     jvmResult,Param1
                        call    #pushAgain
                        jmp     #dup_x2

{{
_______________________________________________________________________________
function: jb_dup2()
Duplicate the top two words on the stack.

}}
jb_dup2                 call    #pop
                        mov     Tmp,jvmResult
                        call    #popAgain
                        mov     Param2,jvmResult
                        call    #pushAgain
                        mov     Param2,Tmp
                        call    #pushAgain
                        jmp     #dup_x2

{{
_______________________________________________________________________________
function: jb_dup2_x1()
Duplicate the top two words on the stack and insert the copies two words down in the stack.

}}
jb_dup2_x1              call    #pop
                        mov     Tmp,jvmResult
                        call    #popAgain
                        mov     Param2,jvmResult
                        call    #popAgain
                        call    #pushAgain
                        jmp     #dup2_x1

{{
_______________________________________________________________________________
function: jb_dup2_x2()
Duplicate the top two words on the stack and insert the copies three words down in the stack.

}}
jb_dup2_x2              call    #pop
                        mov     Tmp,jvmResult
                        call    #popAgain
                        mov     Param2,jvmResult
                        call    #popAgain
                        mov     jvmEP,jvmResult
                        call    #popAgain
                        call    #pushAgain
                        mov     jvmFP,Param2
                        mov     Param2,Tmp
                        call    #pushAgain
                        mov     Param2,jvmResult
                        call    #pushAgain
                        mov     jvmResult,jvmEP
                        mov     Param2,jvmFP
                        jmp     #dup2_x2

{{
_______________________________________________________________________________
function: jb_swap()
Swap the top two elements on the stack.

}}
jb_swap                 call    #pop
                        mov     Param2,jvmResult
                        call    #pop
                        mov     Tmp,jvmResult
                        jmp     #swap

{{
############################### JVM FUNCTIONS #################################
The parameters of jvm functions are passed via variables like ParamX where X
is the number of parameter.

}}
{{
_______________________________________________________________________________
function: throw()
throw NullPointerException.

uses:   Tmp, jvmTmp
}}
throwNPE                mov     Param1,#jd#kNullPointerException

{{
_______________________________________________________________________________
function: throw(exceptionNumber)
throw one of four runtime exceptions.

param:  Param1 = exceptionNumber
uses:   Tmp, jvmTmp
}}
throw                   mov     Param2,#Param1
                        mov     Param1,#jd#JVM_THROW
                        call    #readJavaIntBE
                        mov     Tmp,jvmResult
                        call    #getJvmFP
                        mov     Param1,jvmFP
                        call    #writeJavaIntBE         'write exceptionNumber to arg0 in current frame (eg. istore_0)
                        call    #getJvmPC
                        mov     jvmEP,jvmPC
                        call    #updateJvmEP            'remember where exception is thrown
                        mov     Param1,Tmp
                        add     Param1,#jd#JVM_CODE
                        call    #readJavaIntBE
                        mov     jvmPC,jvmResult
                        call    #updateJvmPC            'set new pc to method throwVMException
                        jmp     #sendReady
  
{{
_______________________________________________________________________________
function: doNative(nativeFunc)
Execute a native function. Here only function 0 and 1 is handled. All others
will be handled by another cog.

param:  Param1 = id of function
uses:   jvmTmp, Param2
}}
doNative                jmp     #:callNative
{
                        cmp     Param1,#1  wc, wz       'Z = 1 if native function equal 1
        if_a            jmp     #:callNative            'not handled by this cog
                        call    #pop
        if_nz           mov     Parma2,jvmResult        
        if_nz           call    #popAgain
                        mov     Param1,jvmResult
        if_nz           call    #writeRegister
        if_z            call    #readRegister
        if_z            mov     Param1,jvmResult
        if_z            call    #pushAgain
                        jmp     #doNative_ret
}                        
:callNative             mov     jvmTmp,PtrJemCode
                        add     jvmTmp,#1               'calculate communication address
                        wrbyte  Param1,jvmTmp
:wait4process           rdbyte  Param1,jvmTmp           'wait until native function is processed
                        tjnz    Param1,#:wait4process
doNative_ret            ret

{{
_______________________________________________________________________________
function: pop()
Pop word from the stack.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
pop                     call    #getJvmSP
{{
_______________________________________________________________________________
function: popAgain()
Pop word from the stack if the jvmSP is already available.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
popAgain                call    #decJvmSP2
                        mov     Param1,jvmSP
                        call    #readJavaIntBE
pop_ret
popAgain_ret            ret

{{
_______________________________________________________________________________
function: popi2l()
Pop word from the stack and convert it to signed long.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
popi2l                  call    #pop
                        jmp     #popi2lInternal

{{
_______________________________________________________________________________
function: popi2lAgain()
Pop word from the stack if the jvmSP is already available
and convert it to signed long.

return: jvmReturn = value form stack
uses:   jvmTmp
}}
popi2lAgain             call    #popAgain
popi2lInternal          mov     Param1,jvmResult
                        call    #i2l
popi2l_ret
popi2lAgain_ret         ret

{{
_______________________________________________________________________________
function: push(value)
Push word onto the stack.

param:  Param1 = value
uses:   jvmTmp, Param2
}}
push                    mov     Param2,Param1
                        call    #getJvmSP
{{
_______________________________________________________________________________
function: pushAgain(value)
Push word onto the stack if the jvmSP is already available.

param:  Param2 = value
uses:   jvmTmp, Param1
}}
pushAgain               mov     Param1,jvmSP
                        call    #writeJavaIntBE
                        call    #incJvmSP2
push_ret
pushAgain_ret           ret

{{
_______________________________________________________________________________
function: readJavaByte(address)
read value from java program.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaByte            call    #getJavaProg
                        mov     jvmTmp,javaProg
                        add     jvmTmp,Param1
                        rdbyte  jvmResult,jvmTmp
readJavaByte_ret        ret

{{
_______________________________________________________________________________
function: readJavaIntBE(address)
read value from java program using big endian.

param:  Param1 = address
return: jvmResult = value read
uses:   jvmTmp
}}
readJavaIntBE           call    #getJavaProg
                        mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        rdbyte  jvmResult,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        shl     jvmResult,#8
                        rdbyte  jvmTmp,jvmTmp
                        or      jvmResult,jvmTmp
readJavaIntBE_ret       ret

{{
_______________________________________________________________________________
function: writeJavaIntBE(address, value)
write value to java program using big endian.

param:  Param1 = address
        Param2 = value
uses:   jvmTmp
}}
writeJavaIntBE          call    #getJavaProg
                        mov     jvmTmp,Param1
                        add     jvmTmp,javaProg
                        ror     Param2,#8
                        wrbyte  Param2,jvmTmp
                        add     jvmTmp,#jd#JVM_INT_SIZE/2
                        rol     Param2,#8
                        wrbyte  Param2,jvmTmp
writeJavaIntBE_ret      ret

{{
_______________________________________________________________________________
function: writeRegister(address, value)
write value to register.

param:  Param1 = address
        Param2 = value
uses:   jvmTmp
}}
{
writeRegister           and     Param1,#$FF
                        cmp     Param1,#jd#nmPeriph0Bank  wc
        if_b            jmp     #:chkPorts
                        cmp     Param1,#jd#nmPeriph0Bank + (jd#MAX_NUM_VPS * 16 - 1)  wc, wz
        if_c_OR_z       sub     Param1,#jd#nmPeriph0Bank
        if_c_OR_z       add     Param1,#jd#varVpRambank
        if_c_OR_z       add     Param1,PtrJvmVars
        if_c_OR_z       wrbyte  Param2,Param1       
        if_a            jmp     #writeRegister_ret
        
:chkPorts               cmp     Param1,#jd#nmPortA
                        

'  address &= $FF
'  case address
'    nmPeriph0Bank..(nmPeriph0Bank+MAX_NUM_VPS*16-1):
'      vpRambank[address-nmPeriph0Bank] := value
'    nmPortA: outa[7..0] := value
'    nmPortB: outa[15..8] := value
'    nmPortC: outa[23..16] := value
'    nmPortD: outa[31..24] := value

writeRegister_ret       ret
}
{{

############################# INTERNAL FUNCTIONS ##############################
}}
{{
_______________________________________________________________________________
function: b2i(value)
value is a signed 1 byte constant: if value < 128 const = value
                                   else const = value | $FF00.

param:  jvmResult = value
return: jvmResult = converted value
}}
b2i                     cmp     jvmResult,#128  wc
        if_nc           or      jvmResult,MASK_WORD_HBYTE
b2i_ret                 ret

{{
_______________________________________________________________________________
function: i2l(value)
value is a signed 2 byte constant: if value < 32768 const = value
                                   else const = value | $FFFF_0000.

param:  jvmResult = value
return: jvmResult = converted value
}}
i2l                     cmp     jvmResult,K32768  wc
        if_nc           or      jvmResult,MASK_LONG_HWORD
i2l_ret                 ret

{{
_______________________________________________________________________________
function: getJavaProg()
get address of java program storage area from main memory.

return: javaProg
uses:   jvmVar
}}
getJavaProg             mov     jvmVar,#jd#varJavaProg
                        call    #getJvmVar
                        mov     javaProg,jvmVar
getJavaProg_ret         ret

{{
_______________________________________________________________________________
function: getJvmEP()
get exception program counter from main memory.

return: jvmEP
uses:   jvmVar
}}
getJvmEP                mov     jvmVar,#jd#varJvmEP
                        call    #getJvmVar
                        mov     jvmEP,jvmVar
getJvmEP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmFP()
update exception program counter in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmEP             mov     jvmTmp,jvmEP
                        mov     jvmVar,#jd#varJvmEP
                        call    #updateJvmVar
updateJvmEP_ret         ret

{{
_______________________________________________________________________________
function: getJvmFP()
get frame pointer from main memory.

return: jvmFP
uses:   jvmVar
}}
getJvmFP                mov     jvmVar,#jd#varJvmFP
                        call    #getJvmVar
                        mov     jvmFP,jvmVar
getJvmFP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmFP()
update frame pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmFP             mov     jvmTmp,jvmFP
                        mov     jvmVar,#jd#varJvmFP
                        call    #updateJvmVar
updateJvmFP_ret         ret

{{
_______________________________________________________________________________
function: getJvmMP()
get method pointer from main memory.

return: jvmMP
uses:   jvmVar
}}
getJvmMP                mov     jvmVar,#jd#varJvmMP
                        call    #getJvmVar
                        mov     jvmMP,jvmVar
getJvmMP_ret            ret

{{
_______________________________________________________________________________
function: updateJvmMP()
update method pointer in main memory.

uses:   jvmTmp, jvmVar
}}
updateJvmMP             mov     jvmTmp,jvmMP
                        mov     jvmVar,#jd#varJvmMP
                        call    #updateJvmVar
updateJvmMP_ret         ret

{{
_______________________________________________________________________________
function: getJvmPC()
get program counter from main memory.

return: jvmPC
uses:   jvmVar
}}
getJvmPC                mov     jvmVar,#jd#varJvmPC
                        call    #getJvmVar
                        mov     jvmPC,jvmVar
getJvmPC_ret            ret

{{
_______________________________________________________________________________
function: incJvmPC()
increments program counter by 1.

uses:   jvmTmp, jvmVar
}}
incJvmPC                call    #getJvmPC
incJvmPCAgain           add     jvmPC,#1
updateJvmPC             mov     jvmTmp,jvmPC
                        mov     jvmVar,#jd#varJvmPC
                        call    #updateJvmVar
incJvmPC_ret
incJvmPCAgain_ret
incJvmPC2Again_ret
incJvmPC3_ret
incJvmPC3Again_ret
addN2JvmPC_ret
addN2JvmPCAgain_ret
updateJvmPC_ret         ret

{{
_______________________________________________________________________________
function: incJvmPC2()
increments program counter by 2.

uses:   jvmTmp, jvmVar
}}
incJvmPC2Again          add     jvmPC,#2
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: incJvmPC3()
increments program counter by 3.

uses:   jvmTmp, jvmVar
}}
incJvmPC3               call    #getJvmPC
incJvmPC3Again          add     jvmPC,#3
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: addN2JvmPC(diff)
adds given diff to program counter.

param:  jvmTmp = diff to add
uses:   jvmVar
}}
addN2JvmPC              call    #getJvmPC
addN2JvmPCAgain         add     jvmPC,jvmTmp
                        jmp     #updateJvmPC

{{
_______________________________________________________________________________
function: getJvmSP()
get stack pointer from main memory.

return: jvmSP
uses:   jvmVar
}}
getJvmSP                mov     jvmVar,#jd#varJvmSP
                        call    #getJvmVar
                        mov     jvmSP,jvmVar
getJvmSP_ret            ret

{{
_______________________________________________________________________________
function: decJvmSP2()
decrements stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
decJvmSP2               sub     jvmSP,#2
                        jmp     #updateJvmSP

{{
_______________________________________________________________________________
function: incJvmSP2()
increments stack pointer by 2 and updates it in main memory.

uses:   jvmTmp, jvmVar
}}
incJvmSP2               add     jvmSP,#2
updateJvmSP             mov     jvmTmp,jvmSP
                        mov     jvmVar,#jd#varJvmSP
                        call    #updateJvmVar
decJvmSP2_ret
incJvmSP2_ret
updateJvmSP_ret         ret

{{
_______________________________________________________________________________
function: getJvmVar(variable)
get a jvm variable from main memory.

param:  jvmVar = variable to get
return: jvmVar = value of jvm variable
}}
getJvmVar               add     jvmVar,PtrJvmVars
                        rdword  jvmVar,jvmVar
getJvmVar_ret           ret

{{
_______________________________________________________________________________
function: updateJvmVar(variable, value)
updates a jvm variable in main memory with the given value.

param:  jvmVar = variable to update
        jvmTmp = value to set
uses:   jvmVar
}}
updateJvmVar            add     jvmVar,PtrJvmVars
                        wrword  jvmTmp,jvmVar
updateJvmVar_ret        ret


K32768                  long    $8000
MASK_WORD               long    $FFFF
MASK_WORD_HBYTE         long    $FF00
MASK_LONG_HWORD         long    $FFFF_0000
PtrJemCodeJmpTable      long    0-0
PtrJemCode              long    0-0
PtrJvmVars              long    0-0

'                        long    $88338833[4]          'currently 4 longs left
_jemcode                res     1
Param1                  res     1
Param2                  res     1
Tmp                     res     1
jvmResult               res     1
jvmTmp                  res     1
jvmVar                  res     1
javaProg                res     1
jvmEP                   res     1
jvmFP                   res     1
jvmMP                   res     1
jvmPC                   res     1
jvmSP                   res     1
                        fit     $1F0
'

DAT

JemCodeJmpTable         word    0                                     'Jem_NOP          
                        word    (@jb_iconst_M1 - @handlerEntry)/4     'Jem_ICONST_M1
                        word    (@jb_iconst_0 - @handlerEntry)/4      'Jem_ICONST_0
                        word    (@jb_iconst_1 - @handlerEntry)/4      'Jem_ICONST_1
                        word    (@jb_iconst_2 - @handlerEntry)/4      'Jem_ICONST_2
                        word    (@jb_iconst_3 - @handlerEntry)/4      'Jem_ICONST_3
                        word    (@jb_iconst_4 - @handlerEntry)/4      'Jem_ICONST_4
                        word    (@jb_iconst_5 - @handlerEntry)/4      'Jem_ICONST_5
                        word    (@jb_bipush - @handlerEntry)/4        'Jem_BIPUSH
                        word    (@jb_sipush - @handlerEntry)/4        'Jem_SIPUSH
                        word    (@jb_iload - @handlerEntry)/4         'Jem_ILOAD
                        word    (@jb_iload_0 - @handlerEntry)/4       'Jem_ILOAD_0
                        word    (@jb_iload_1 - @handlerEntry)/4       'Jem_ILOAD_1
                        word    (@jb_iload_2 - @handlerEntry)/4       'Jem_ILOAD_2
                        word    (@jb_iload_3 - @handlerEntry)/4       'Jem_ILOAD_3
                        word    (@jb_istore - @handlerEntry)/4        'Jem_ISTORE
                        word    (@jb_istore_0 - @handlerEntry)/4      'Jem_ISTORE_0
                        word    (@jb_istore_1 - @handlerEntry)/4      'Jem_ISTORE_1
                        word    (@jb_istore_2 - @handlerEntry)/4      'Jem_ISTORE_2
                        word    (@jb_istore_3 - @handlerEntry)/4      'Jem_ISTORE_3
                        word    (@jb_ifeq - @handlerEntry)/4          'Jem_IFEQ
                        word    (@jb_ifne - @handlerEntry)/4          'Jem_IFNE
                        word    (@jb_iflt - @handlerEntry)/4          'Jem_IFLT
                        word    (@jb_ifle - @handlerEntry)/4          'Jem_IFLE
                        word    (@jb_ifgt - @handlerEntry)/4          'Jem_IFGT
                        word    (@jb_ifge - @handlerEntry)/4          'Jem_IFGE
                        word    (@jb_if_icmpeq - @handlerEntry)/4     'Jem_IF_ICMPEQ
                        word    (@jb_if_icmpne - @handlerEntry)/4     'Jem_IF_ICMPNE
                        word    (@jb_if_icmplt - @handlerEntry)/4     'Jem_IF_ICMPLT
                        word    (@jb_if_icmpge - @handlerEntry)/4     'Jem_IF_ICMPGE
                        word    (@jb_if_icmpgt - @handlerEntry)/4     'Jem_IF_ICMPGT
                        word    (@jb_if_icmple - @handlerEntry)/4     'Jem_IF_ICMPLE
                        word    (@jb_if_acmpeq - @handlerEntry)/4     'Jem_IF_ACMPEQ
                        word    (@jb_if_acmpne - @handlerEntry)/4     'Jem_IF_ACMPNE
                        word    (@jb_ireturn - @handlerEntry)/4       'Jem_IRETURN
                        word    (@jb_return - @handlerEntry)/4        'Jem_RETURN
                        word    (@jb_invokevirtual - @handlerEntry)/4 'Jem_INVOKEVIRTUAL
                        word    (@jb_invokestatic - @handlerEntry)/4  'Jem_INVOKESTATIC
                        word    (@jb_getstatic - @handlerEntry)/4     'Jem_GETSTATIC
                        word    (@jb_putstatic - @handlerEntry)/4     'Jem_PUTSTATIC
                        word    (@jb_pop - @handlerEntry)/4           'Jem_POP
                        word    (@jb_pop2 - @handlerEntry)/4          'Jem_POP2
                        word    (@jb_dup - @handlerEntry)/4           'Jem_DUP
                        word    (@jb_dup_x1 - @handlerEntry)/4        'Jem_DUP_X1
                        word    (@jb_dup_x2 - @handlerEntry)/4        'Jem_DUP_X2
                        word    (@jb_dup2 - @handlerEntry)/4          'Jem_DUP2
                        word    (@jb_dup2_x1 - @handlerEntry)/4       'Jem_DUP2_X1
                        word    (@jb_dup2_x2 - @handlerEntry)/4       'Jem_DUP2_X2
                        word    (@jb_swap - @handlerEntry)/4          'Jem_SWAP
'      